<?php
/*
Plugin Name: External Links Nofollow 
Plugin URI: http://techlister.com
Description: Adds rel="nofollow" to all external links within post content.
Version: 1.0
Author: Pelister
Author URI: http://techlister.com

Copyright 2012 Pelister ( email: pelister@techlister.com )
*/

if ( !class_exists( 'extLinksNofollow' ) ) {
	class extLinksNofollow
	{
		static function init( )
		{
			add_filter( 'the_content', array(__CLASS__, 'nofollow') );
		}

		function nofollow( $content )
		{
			return preg_replace_callback( '/<a[^>]+/', array( __CLASS__, 'callback' ), $content );
		}

		function callback( $matches )
		{
			$link = $matches[0];
			$site_link = get_bloginfo( 'url' );

			if ( strpos( $link, 'rel' ) === false ) 
			{
				$link = preg_replace( "%(href=\S(?!$site_link))%i", 'rel="nofollow" $1', $link );
			} 
			elseif ( preg_match( "%href=\S(?!$site_link)%i", $link ) && ( strpos( $link, 'author' ) === false ) ) //check for embedded rel='author' within content.
			{
				$link = preg_replace( '/rel=\S(?!nofollow)\S*/i', 'rel="nofollow"', $link );
			}
			
			return $link;
		}
	}
	
	extLinksNofollow::init( );
}
?>